# coding: utf-8

"""
    UltraCart Rest API V2

    UltraCart REST API Version 2  # noqa: E501

    OpenAPI spec version: 2.0.0
    Contact: support@ultracart.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


import pprint
import re  # noqa: F401

import six


class OrderCoupon(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'accounting_code': 'str',
        'automatically_applied': 'bool',
        'base_coupon_code': 'str',
        'coupon_code': 'str',
        'hdie_from_customer': 'bool'
    }

    attribute_map = {
        'accounting_code': 'accounting_code',
        'automatically_applied': 'automatically_applied',
        'base_coupon_code': 'base_coupon_code',
        'coupon_code': 'coupon_code',
        'hdie_from_customer': 'hdie_from_customer'
    }

    def __init__(self, accounting_code=None, automatically_applied=None, base_coupon_code=None, coupon_code=None, hdie_from_customer=None):  # noqa: E501
        """OrderCoupon - a model defined in Swagger"""  # noqa: E501

        self._accounting_code = None
        self._automatically_applied = None
        self._base_coupon_code = None
        self._coupon_code = None
        self._hdie_from_customer = None
        self.discriminator = None

        if accounting_code is not None:
            self.accounting_code = accounting_code
        if automatically_applied is not None:
            self.automatically_applied = automatically_applied
        if base_coupon_code is not None:
            self.base_coupon_code = base_coupon_code
        if coupon_code is not None:
            self.coupon_code = coupon_code
        if hdie_from_customer is not None:
            self.hdie_from_customer = hdie_from_customer

    @property
    def accounting_code(self):
        """Gets the accounting_code of this OrderCoupon.  # noqa: E501

        QuickBooks accounting code for this coupon  # noqa: E501

        :return: The accounting_code of this OrderCoupon.  # noqa: E501
        :rtype: str
        """
        return self._accounting_code

    @accounting_code.setter
    def accounting_code(self, accounting_code):
        """Sets the accounting_code of this OrderCoupon.

        QuickBooks accounting code for this coupon  # noqa: E501

        :param accounting_code: The accounting_code of this OrderCoupon.  # noqa: E501
        :type: str
        """

        self._accounting_code = accounting_code

    @property
    def automatically_applied(self):
        """Gets the automatically_applied of this OrderCoupon.  # noqa: E501

        Whether or not the coupon was automatically applied to the order  # noqa: E501

        :return: The automatically_applied of this OrderCoupon.  # noqa: E501
        :rtype: bool
        """
        return self._automatically_applied

    @automatically_applied.setter
    def automatically_applied(self, automatically_applied):
        """Sets the automatically_applied of this OrderCoupon.

        Whether or not the coupon was automatically applied to the order  # noqa: E501

        :param automatically_applied: The automatically_applied of this OrderCoupon.  # noqa: E501
        :type: bool
        """

        self._automatically_applied = automatically_applied

    @property
    def base_coupon_code(self):
        """Gets the base_coupon_code of this OrderCoupon.  # noqa: E501

        Coupon code configured by the merchant.  Will differ if the customer used a one time coupon code generated off this base coupon  # noqa: E501

        :return: The base_coupon_code of this OrderCoupon.  # noqa: E501
        :rtype: str
        """
        return self._base_coupon_code

    @base_coupon_code.setter
    def base_coupon_code(self, base_coupon_code):
        """Sets the base_coupon_code of this OrderCoupon.

        Coupon code configured by the merchant.  Will differ if the customer used a one time coupon code generated off this base coupon  # noqa: E501

        :param base_coupon_code: The base_coupon_code of this OrderCoupon.  # noqa: E501
        :type: str
        """
        if base_coupon_code is not None and len(base_coupon_code) > 20:
            raise ValueError("Invalid value for `base_coupon_code`, length must be less than or equal to `20`")  # noqa: E501

        self._base_coupon_code = base_coupon_code

    @property
    def coupon_code(self):
        """Gets the coupon_code of this OrderCoupon.  # noqa: E501

        Coupon code entered by the customer  # noqa: E501

        :return: The coupon_code of this OrderCoupon.  # noqa: E501
        :rtype: str
        """
        return self._coupon_code

    @coupon_code.setter
    def coupon_code(self, coupon_code):
        """Sets the coupon_code of this OrderCoupon.

        Coupon code entered by the customer  # noqa: E501

        :param coupon_code: The coupon_code of this OrderCoupon.  # noqa: E501
        :type: str
        """
        if coupon_code is not None and len(coupon_code) > 20:
            raise ValueError("Invalid value for `coupon_code`, length must be less than or equal to `20`")  # noqa: E501

        self._coupon_code = coupon_code

    @property
    def hdie_from_customer(self):
        """Gets the hdie_from_customer of this OrderCoupon.  # noqa: E501

        True if this coupon is hide from the customer  # noqa: E501

        :return: The hdie_from_customer of this OrderCoupon.  # noqa: E501
        :rtype: bool
        """
        return self._hdie_from_customer

    @hdie_from_customer.setter
    def hdie_from_customer(self, hdie_from_customer):
        """Sets the hdie_from_customer of this OrderCoupon.

        True if this coupon is hide from the customer  # noqa: E501

        :param hdie_from_customer: The hdie_from_customer of this OrderCoupon.  # noqa: E501
        :type: bool
        """

        self._hdie_from_customer = hdie_from_customer

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(OrderCoupon, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, OrderCoupon):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
